routes/web.php
<?php

use App\Http\Controllers\AccountController;
use App\Http\Controllers\AdController;
use App\Http\Controllers\Api\AuthController;
use App\Http\Controllers\ContractController;
use App\Http\Controllers\MailController;
use App\Http\Controllers\PropertyController;
use App\Http\Controllers\SubscriptionController;
use App\Http\Controllers\ChartJSController;
use App\Http\Controllers\UserController;
use App\Http\Controllers\WalletController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

//Route::get('/', function () {
//    return view('home.home');
//});

//Route::get('/index', function () {
//    return view('users.index');
//});

Route::get('/charts', [ChartJSController::class, 'index'])->name('charts.index');

Route::get('/sendCode', [MailController::class, 'index']);

Route::get('/login', [AuthController::class, 'login']);

Route::view('/', 'Auth.auth')->name('auth');


//Auth::routes();
Route::get('/home', [AccountController::class, 'showAll'])->name('home');


//Route::group(['middleware' => ['auth:web', 'isActive']], function () {

Route::group(['prefix' => 'accounts'], function () {
    Route::get('/', [AccountController::class, 'showAll'])->name('accounts.index');
    Route::get('/create', [AccountController::class, 'create'])->name('accounts.create');
    Route::post('/createAccount', [AuthController::class, 'createAccount'])->name('accounts.store');
    Route::get('/{account_id}/show', [AccountController::class, 'showAccount'])->name('accounts.show');
    Route::get('/{account_id}/edit', [AccountController::class, 'edit'])->name('accounts.edit');
    Route::post('/update', [AccountController::class, 'update'])->name('accounts.update');
    Route::delete('/delete/{account_id}', [AccountController::class, 'destroy'])->name('accounts.destroy');
    Route::get('/search', [AccountController::class, 'search'])->name('accounts.search');
    Route::post('/blocked', [AccountController::class, 'accountBlock'])->name('accounts.blocked');
});

Route::prefix('ads/')->group(function () {
    Route::get('index', [AdController::class, 'showAll'])->name('ads.index');
    Route::post('create', [AdController::class, 'store'])->name('ads.store');
    Route::view('create','ads.create')->name('ads.create');
    Route::post('update/{ad_id}', [AdController::class, 'update'])->name('ads.update');
    Route::get('show/{ad_id}', [AdController::class, 'showAd'])->name('ads.show');
    Route::get('editAd/{ad_id}', [AdController::class, 'editAd'])->name('ads.edit');
    Route::delete('delete/{ad_id}', [AdController::class, 'destroy'])->name('ads.delete');
    Route::post('uploadImg/{ad_id}', [AdController::class, 'uploadImg'])->name('ads.uploadImg');
});

Route::prefix('orders/')->group(function () {
    Route::get('showAllOrdersProperty', [PropertyController::class, 'showAllOrdersProperty'])->name('orders.index');
    Route::post('acceptRefuse', [PropertyController::class, 'acceptRefuse'])->name('orders.acceptRefuse');
    Route::get('show/{property_id}', [PropertyController::class, 'showProperty'])->name('orders.showProperty');

    Route::get('showAllOrdersContract', [ContractController::class, 'showAllOrdersContract'])->name('ordersContract.index');
    Route::post('acceptRefuseContract', [ContractController::class, 'acceptRefuse'])->name('ordersContract.acceptRefuse');
    Route::get('showContract/{contract_id}', [ContractController::class, 'showContract'])->name('ordersContract.showContract');
});


Route::prefix('subscriptions/')->name('subscriptions.')->group(function () {
    Route::get('index', [SubscriptionController::class, 'showAll'])->name('index');
    Route::view('create','subscriptions.create')->name('create');
    Route::post('create', [SubscriptionController::class, 'create'])->name('store');
    Route::delete('delete/{subscription_id}', [SubscriptionController::class, 'destroy'])->name('destroy');
    Route::get('show/{subscription_id}', [SubscriptionController::class, 'show'])->name('show');
    Route::post('update/{subscription_id}', [SubscriptionController::class, 'update'])->name('update');
    Route::get('edit/{subscription_id}', [SubscriptionController::class, 'edit'])->name('edit');
});


Route::prefix('wallets/')->name('wallets.')->group(function (){
    Route::get('index',[WalletController::class,'index'])->name('index');
    Route::post('chargeWallet',[WalletController::class,'chargeWallet'])->name('chargeWallet');
    Route::post('create',[WalletController::class,'create'])->name('create');
    Route::get('show/{wallet_id}',[WalletController::class,'show'])->name('show');
    Route::get('edit/{wallet_id}',[WalletController::class,'edit'])->name('edit');
    Route::delete('delete/{wallet_id}',[WalletController::class,'destroy'])->name('destroy');
});

//});

app/Models/Wallet.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Wallet extends Model
{
    use HasFactory;

    protected $table = 'wallets';

    protected $primaryKey = 'id';

    public $timestamps = false;

    protected $fillable = [
        'user_id',
        'amount'
    ];

    protected $hidden = [
        'created_at',
        'updated_at',
    ];

    public function user()
    {
        return $this->belongsTo(User::class, 'user_id');
    }
}

app/Http/Controllers/WalletController.php
<?php

namespace App\Http\Controllers;

use App\Models\User;
use App\Models\Wallet;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class WalletController extends Controller
{

    public function index()
    {
        $wallets = Wallet::with('user.account')->latest()->paginate(6);

        return view('wallets.index',['wallets'=>$wallets]);
    }

    public function show()
    {
        $wallet = Wallet::with('user')->find(Auth::id());

        if($wallet){

            return response()->json([
                'code' => '200',
                'Status' => 'Success',
                'Message'  => 'View user with his/her wallet',
                'wallet' => $wallet
            ]);
        }
        return response()->json([
            'code' => '400',
            'Status' => 'Failed',
            'Message'  => 'Wallet not found',
        ]);
    }

    public function chargeWallet(Request $request)
    {
        $wallet = Wallet::with('user')->find($request->wallet_id);

        if($wallet){

            $wallet->update([
                'amount' => $wallet->amount + $request->amount
            ]);

            return response()->json([
                'code' => '200',
                'Status' => 'Success',
                'Message'  => 'Wallet has been charged successfully',
//                'wallet' => $wallet
            ]);
        }
        return response()->json([
            'code' => '400',
            'Status' => 'Failed',
            'Message'  => 'Wallet not found',
        ]);
    }

    public function destroy($wallet_id)
    {
        $wallet = Wallet::find($wallet_id);

        if($wallet){

            $wallet->delete();

            return response()->json([
                'code' => '200',
                'Status' => 'Success',
                'Message'  => 'Wallet has been deleted successfully',
                'wallet' => $wallet
            ]);
        }
        return response()->json([
            'code' => '400',
            'Status' => 'Failed',
            'Message'  => 'Wallet not found',
        ]);
    }

    public function create(Request $request){

        $user = User::find($request->user_id);

        if($user){

            $wallet = Wallet::where('user_id',$request->user_id)->first();

            if($wallet){
                return response()->json([
                    'code' => '400',
                    'Status' => 'Failed',
                    'Message'  => 'Wallet is already exist',
                ]);
            }

            $wallet = Wallet::with('user')->create([
                'user_id' => $user->id
            ]);

            return response()->json([
                'code' => '200',
                'Status' => 'Success',
                'Message'  => 'Wallet has been created successfully',
                'wallet' => $wallet
            ]);

        }
        return response()->json([
            'code' => '400',
            'Status' => 'Failed',
            'Message'  => 'User not found',
        ]);

    }

}

resources/views/wallets/index.blade.php
@extends('home.home')

@section('content')

    <h1 class="mb- text-center">Wallets Management</h1>

    <div class="bg-light p-4 rounded">

        <div class="row justify-content-end">
            <div class="col-11">
                <h1>Wallets</h1>
            </div>
            <div class="col-1">

            </div>
        </div>

        <div style=" height: 100% !important;
            width: auto !important;
            overflow: auto !important;">
            <table class="table table-striped" id="myTable" style="">
                <thead>
                <tr>
                    <th scope="col"
                        width="1%"
                    >ID
                    </th>
                    <th scope="col"
                        width="10%"
                    >Full Name
                    </th>
                    <th scope="col" width="10%">Email</th>
                    <th scope="col"
                        width="10%"
                    >Phone Number
                    </th>
                    <th scope="col"
                        width="10%"
                    >Value
                    </th>
                    <th scope="col"
                        width="10%">Cash Transfer
                    </th>
                    <th scope="col"
                        width="10%"
                        colspan="3">Action
                    </th>

                </tr>
                </thead>
                <tbody>
                @foreach($wallets as $wallet)
                    <tr>
                        <th scope="row">{{ $wallet->id }}</th>
                        <td>{{ $wallet->user->account->firstName}} {{$wallet->user->account->lastName}}</td>
                        <td>{{ $wallet->user->account->email }}</td>
                        <td>0{{ $wallet->user->account->phoneNumber }}</td>
                        <td><span class="badge rounded-pill bg-dark"
                                  style="font-size: 16px">{{ $wallet->amount }}</span></td>
                        <td>
                            <div class="d-flex justify-content-center">
                                <input type="number" class="form-control amount">
                            </div>
                        </td>
                        <td>
                            <div class="d-flex justify-content-center">
                                <button class="btn btn-primary btn-sm charge">Charge</button>
                            </div>
                        </td>
                    </tr>
                @endforeach
                </tbody>
            </table>

            @if(!isset($paginate))
                <div class="d-flex justify-content-center">
                    {!! $wallets->links() !!}
                </div>
            @endif

        </div>
    </div>

@endsection

@section('scripts')
    <script>
        $.ajaxSetup({
            headers: {
                'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
            }
        });
    </script>
    <script>

        $('.wallets').addClass("btnFocused");


        $(document).ready(function () {
            $('.charge').click(function () {
                var currentRow = $(this).closest("tr");
                var wallet_id = currentRow.find("th:eq(0)").text();
                var amount = currentRow.find(".amount").val();
                console.log(amount)

                $.ajax({
                    url: "{{route('wallets.chargeWallet')}}",
                    data: {
                        amount: amount,
                        wallet_id: wallet_id
                    },
                    type: "POST",
                    success: function (response) {
                        JSON.stringify(response);
                        console.log(response)
                        setTimeout(function () {
                            location.reload();
                        }, 200);
                    }
                });
            });
        });
    </script>
@endsection